//
//  WrapperThread.m
//  queryRowsSample
//
//  Created on 2018/02/04.
//

#import "WrapperThread.h"

@implementation WrapperThread

-(void) start {
    
    _stat = 0;
    
    [[[NSOperationQueue alloc] init] addOperationWithBlock:^{
        
        // dblib connect
        _db = [[dbLib alloc] init];
        _db.url = @"http://192.168.10.110:82";      // <== change here
        _db.delegate = self;
        
        dbLibStatus rc = [_db connect];
        
        if(rc != Normal) {
            NSLog(@"connect failed %d",rc);
            return;
        }
        
        while(_stat==0){
            [[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:0.5]];
        }
        
        rc = [_db queryRows:@"select EMPNO,ENAME from emp order by empno" :0];
        
        if(rc){
            NSLog(@"query rows request failed");
        }

        while(_stat==1){
            [[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:0.5]];
        }
        
        NSLog(@"got data");
        
        if(_stat==2 && [_delegate respondsToSelector:@selector(doUIWork:)]){
            // メインスレッド実行
            dispatch_async(dispatch_get_main_queue(), ^{
                // 描画処理
                [_delegate doUIWork:_rows];
            });
        }
        NSLog(@"finished");
    }];
}

-(void) requestCompleted:(NSString*) methodName {
    
    NSLog(@"request completed %@",methodName);
    
    if([methodName isEqualToString:@"Login"]){
        _stat = 1;
    }
}

-(void) requestFailed:(NSString*)methodName :(NSError *)error {
    _stat = 9;
    NSLog(@"request failed %@ %@",methodName,_db.lastErrorText);
}

-(void) queryRowsCompleted:(NSMutableArray *)rows {
    _rows = rows;
    _stat =2;
    
    for(int i=0; i< [rows count]; i++){
        NSMutableDictionary* row = rows[i];
        NSString* empno = [row objectForKey:@"EMPNO"];
        NSString* ename = [row objectForKey:@"ENAME"];
        NSLog(@"%@ %@",empno,ename);
    }
    
    NSLog(@"query rows completed");
}


@end
